# -*- coding: utf-8 -*-
#==============================================================================
#
#   E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (www.iee-einstein.org)
#
#------------------------------------------------------------------------------
#
#   WRITECONFIG
#
#------------------------------------------------------------------------------
#
#   auxiliary tool for writing configuration file during installation
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================
from optparse import OptionParser
import ConfigParser
from ConfigParser import DuplicateSectionError
import ctypes
import os
import sys
parser = OptionParser()
(options, args) = parser.parse_args()
sys.path.append(os.path.abspath(args[0]+"\src"))
import einstein.modules.constants as c

try:   
    if not os.path.exists(c.APPDATA):
        os.makedirs(c.APPDATA)
    config = ConfigParser.RawConfigParser()
    config.read(str(c.APPDATA + "\einstein.ini"))
    #Set needed Configurations
    try:
        config.add_section("DB")
    except DuplicateSectionError:
        pass 
    config.set("DB", "dbhost", "-")
    config.set("DB", "mysqlbin", "-")
    config.set("DB", "DBname", "einstein")
    config.set("DB", "DBuser", "-")
    if len(args)>4:
        config.set("DB", "DBpass", str(args[4]))
    else:
        config.set("DB", "DBpass", "")
    iniFile = open(str(c.APPDATA + "\einstein.ini"), "w")
    config.write(iniFile)
except Exception, e:
    raise
    import sys, traceback
    exc_type, exc_value, exc_traceback = sys.exc_info()
    errorFile = open(c.APPDATA + "\einsteininstall.log", "a")
    traceback.print_exception(exc_type, exc_value, exc_traceback,
                              limit=2, file=errorFile)
    errorFile.close()
    raise
iniFile.close()
