# -*- coding: utf-8 -*-
#==============================================================================
#
#	E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (www.iee-einstein.org)
#
#------------------------------------------------------------------------------
#
#	DBEditFrame
#			
#------------------------------------------------------------------------------
#			
#	Data base editing window
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------		
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================
import wx
from panels.Q.panelQ4 import PanelQ4
from GUI.status import Status
from globals import Globals
from modules.messageLogger import *
from auxiliary.auxiliary import toGettextAndUnicode as _U
from panels.DB.panelDBCHP import PanelDBCHP
from panels.DB.panelDBHeatPump import PanelDBHeatPump
from panels.DB.panelDBBoiler import PanelDBBoiler

[wxID_AEPOPUP1, #wxID_AEPOPUP1BTNACCEPT, wxID_AEPOPUP1BTNCANCEL, 
 wxID_AEPOPUP1BTNENTERMANUALLY, wxID_AEPOPUP1BTNSELECTFROMDATABASE, 
 wxID_AEPOPUP1LISTBOX1, wxID_AEPOPUP1STATICTEXT1, 
] = [wx.NewId() for _init_ctrls in range(5)]

class ManualAddDialog(wx.Frame):
    def __init__(self, prnt, eqId):
        self.prnt = prnt
        wx.Frame.__init__(self, id=-1, name=u'ManualAddDialog',
              parent=prnt, pos=wx.Point(0, 0), size=wx.Size(1000, 700),
              style=wx.DEFAULT_DIALOG_STYLE, title=_U('Manual equipment add'))

        self.Bind(wx.EVT_CLOSE, self.OnClose)

        self.equipeType = None

        eq = Status.int.systemModel.getObject("EQ", eqId)
        if eq is None: return

        main = Globals.GUI

        self.ret = False
        print "ManualAddDialog: creating PanelQ4"
        import sys
        sys.stdout.flush()
        
        self.p4 = PanelQ4(self, main, eq.no)
        self.p4.display()
        
        self.eqId = eqId
        self.Show()

    def OnClose(self, event):
        if self.ret:
            self.prnt.theId = self.eqId
            self.prnt.EndModal(wx.ID_OK)
        else:
            self.prnt.EndModal(wx.ID_CANCEL)

        self.Destroy()

class AddEquipment(wx.Dialog):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Dialog.__init__(self, id=wxID_AEPOPUP1, name=u'AEPopUp',
              parent=prnt, pos=wx.Point(609, 199), size=wx.Size(529, 447),
              style=wx.DEFAULT_DIALOG_STYLE, title=self.title)
        self.SetClientSize(wx.Size(529, 447))

        self.btnSelectFromDatabase = wx.Button(id=wxID_AEPOPUP1BTNSELECTFROMDATABASE,
              label=_U('Select from database'), name=u'btnSelectFromDatabase',
              parent=self, pos=wx.Point(160, 24), size=wx.Size(192, 32),
              style=0)
        self.btnSelectFromDatabase.Bind(wx.EVT_BUTTON,
              self.OnBtnSelectFromDatabaseButton,
              id=wxID_AEPOPUP1BTNSELECTFROMDATABASE)

        self.btnEnterManually = wx.Button(id=wxID_AEPOPUP1BTNENTERMANUALLY,
              label=_U('Enter manually'), name=u'btnEnterManually', parent=self,
              pos=wx.Point(160, 64), size=wx.Size(192, 32), style=0)
        self.btnEnterManually.Bind(wx.EVT_BUTTON, self.OnBtnEnterManuallyButton,
              id=wxID_AEPOPUP1BTNENTERMANUALLY)

##        self.staticText1 = wx.StaticText(id=wxID_AEPOPUP1STATICTEXT1,
##              label=_U('Retrieve from previously deleted equipment'),
##              name='staticText1', parent=self, pos=wx.Point(120, 128),
##              size=wx.Size(302, 17), style=0)
##
##        self.listBox1 = wx.ListBox(choices=[], id=wxID_AEPOPUP1LISTBOX1,
##              name='listBox1', parent=self, pos=wx.Point(128, 160),
##              size=wx.Size(288, 232), style=0)
##
        self.btnCancel = wx.Button(id=wx.ID_CANCEL, label=_U('Cancel'),
              name=u'btnCancel', parent=self, pos=wx.Point(206, 408),
              size=wx.Size(104, 32), style=0)

        self.btnAccept = wx.Button(id=wx.ID_OK, label=_U('OK'),
              name=u'btnAccept', parent=self, pos=wx.Point(312, 408),
              size=wx.Size(104, 32), style=0)

        self.btnEnterManually.Hide()

#------------------------------------------------------------------------------		
    def __init__(self, parent, module, title, tablename, col_returned, can_edit):
#------------------------------------------------------------------------------		
        self.module = module
        self.title = title
        self.tablename = tablename
        
        # the column that would be returned by DBEditFrame
        self.col_returned = col_returned
        self.can_edit = can_edit

        self.prnt = parent
        self.theId = -1
        self._init_ctrls(parent)

        # create a list of previously deleted equipment for display
#        self.RetrieveDeleted()

#------------------------------------------------------------------------------		
    def OnBtnSelectFromDatabaseButton(self, event):
#------------------------------------------------------------------------------		
#------------------------------------------------------------------------------		

        if self.tablename == "dbchp":
            self.dbe = PanelDBCHP(self, "Edit DBCHP", showOk=True)
        elif self.tablename == "dbheatpump":
            self.dbe = PanelDBHeatPump(self, "Edit DBHeatPump", showOk=True)
        elif self.tablename == "dbboiler":
            self.dbe = PanelDBBoiler(self, "Edit DBBoiler", showOk=True)
        else:
            return

        self.dbe.ShowModal()
        
    def onPseudoModal(self, ret):
        """
        Helper function necessary as a hack, as dbe is not a real modal dialog
        """
        
        if ret == True:
            # the user has accepted a selection from the database dialog
            # so we exit also from this dialog
            #
            #   Here the identity of the selected equipment should be delivered, in order
            #   to give it back to the calling panel
            # this should be cleaned somewhat
            self.theId = self.dbe.selectedId
            #print "addEquipment popup (Database button): ", self.theId
            #print "addEquipment popup (Database button): equipe = ",self.prnt.equipe.Equipment

            try:
                #print "trying to set equipment row in DB "
                self.module.setEquipmentFromDB(self.prnt.equipe, self.theId)
                self.prnt.mode = "DB"
                #print _("addEquipment popup (Database button): equipment added to Q/C")
            except:
                logTrack('addEquipment popup (Database button): setEquipmentFromDB from module did not execute')

            # close this dialog
            self.EndModal(wx.ID_OK)
        else:
            self.EndModal(wx.ID_CANCEL)
        
#------------------------------------------------------------------------------		
    def OnBtnEnterManuallyButton(self, event):
#------------------------------------------------------------------------------		
#   Manual entry selected
#------------------------------------------------------------------------------		
        self.prnt.mode = "Manual"
        logTrack("AddEquipment_popup (Manual Button): adding equipe ID %s"%(self.prnt.equipe.QGenerationHC_ID))
        Status.int.systemModel.build()
        self.dMan = ManualAddDialog(self, self.prnt.equipe.QGenerationHC_ID)
##        if self.dMan.ShowModal() == wx.ID_OK:
##            self.EndModal(wx.ID_OK)
##        else:
##            self.EndModal(wx.ID_CANCEL)

#------------------------------------------------------------------------------		
    def RetrieveDeleted(self):
#------------------------------------------------------------------------------		
        print 'RetrieveDeleted() not yet implemented'
#------------------------------------------------------------------------------		

    
