#!/usr/bin/env python
# -*- coding: utf-8 -*-
#==============================================================================
#
#   E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (www.iee-einstein.org)
#
#------------------------------------------------------------------------------
#
#   DialogA
#
#------------------------------------------------------------------------------
#
#   Dialog for entering alternative name
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================
import wx
from auxiliary.auxiliary import toGettextAndUnicode as _U, toUnicode as U, toUTF8


def create(parent):
    return DialogA(parent)

[wxID_DIALOGA, wxID_DIALOGABUTTONCANCEL, wxID_DIALOGABUTTONOK, 
 wxID_DIALOGASTDESCRIPTION, wxID_DIALOGASTDIALOG1, wxID_DIALOGATCDESCRIPTION, 
 wxID_DIALOGATCSHORTNAME, 
] = [wx.NewId() for _init_ctrls in range(7)]

class DialogA(wx.Dialog):
    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Dialog.__init__(self, id=wxID_DIALOGA, name='DialogA', parent=prnt,
              pos=wx.Point(433, 283), size=wx.Size(400, 188),
              style=wx.DEFAULT_DIALOG_STYLE, title=_U('New alternative proposal'))
        self.SetClientSize(wx.Size(392, 154))

        self.stDialog1 = wx.StaticText(id=wxID_DIALOGASTDIALOG1,
              label=_U('shortname:'), name='stDialog1', parent=self,
              pos=wx.Point(24, 16), size=wx.Size(56, 13), style=0)
        self.stDialog1.Center(wx.HORIZONTAL)

        self.buttonOK = wx.Button(id=wxID_DIALOGABUTTONOK, label=_U('OK'),
              name='buttonOK', parent=self, pos=wx.Point(176, 112),
              size=wx.Size(91, 23), style=0)
        self.buttonOK.Bind(wx.EVT_BUTTON, self.OnButtonOKButton,
              id=wxID_DIALOGABUTTONOK)

        self.buttonCancel = wx.Button(id=wxID_DIALOGABUTTONCANCEL,
              label=_U('cancel'), name='buttonCancel', parent=self,
              pos=wx.Point(280, 112), size=wx.Size(91, 23), style=0)
        self.buttonCancel.Bind(wx.EVT_BUTTON, self.OnButtonCancelButton,
              id=wxID_DIALOGABUTTONCANCEL)

        self.stDescription = wx.StaticText(id=wxID_DIALOGASTDESCRIPTION,
              label=_U('description:'), name='stDescription', parent=self,
              pos=wx.Point(24, 40), size=wx.Size(57, 13), style=0)
        self.stDescription.Center(wx.HORIZONTAL)

        self.tcShortName = wx.TextCtrl(id=wxID_DIALOGATCSHORTNAME,
              name='tcShortName', parent=self, pos=wx.Point(96, 16),
              size=wx.Size(280, 16), style=0, value=_U('new alternative'))
        self.tcShortName.SetMaxLength(45)

        self.tcDescription = wx.TextCtrl(id=wxID_DIALOGATCDESCRIPTION,
              name='tcDescription', parent=self, pos=wx.Point(96, 40),
              size=wx.Size(280, 56), style=wx.TE_MULTILINE ,
              value=_U('describe briefly the new alternative'))
        self.tcDescription.SetMaxLength(1000)
        wx.CallAfter(self.tcShortName.SetFocus) 

    def __init__(self, parent):
        self._init_ctrls(parent)
        self.prnt = parent
        self.tcShortName.SetValue(U(parent.shortName))
        self.tcDescription.SetValue(U(parent.description))

    def OnButtonOKButton(self, event):
        self.prnt.shortName = toUTF8(self.tcShortName.GetValue())
        # GTK+ doesn't honour SetMaxLength, truncate value if necessary 
        self.prnt.description = toUTF8(self.tcDescription.GetValue())[:1000]
        self.EndModal(wx.ID_OK)

    def OnButtonCancelButton(self, event):
        self.EndModal(wx.ID_CANCEL)
