# -*- coding: utf-8 -*-
#==============================================================================
#
#   E I N S T E I N
#
#   Expert System for an Intelligent Supply of Thermal Energy in Industry
#   (www.einstein-energy.net)
#
#------------------------------------------------------------------------------
#
#   NUMCTRL
#
#------------------------------------------------------------------------------
#
#   auxiliary function for plot of numeric values
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================
from itertools import cycle
from auxiliary.auxiliary import toGettextAndUnicode as _U
import locale  

def format_int_wrapper(x, pos = None):
    """
    Wrapper function for format_int
    change separator and comma in locale settings
    """

    separator = _U('\'')
    comma = _U('.')
    return format_int(x, separator, comma);


def format_int(i, sep = '.', com = ','):
    """
    Format a given number with thousands separators and return
    the resulting string
    """

    old_sep = '.'

    minus = '-'
    cyc = cycle(['', '', sep])
    s = str(i)
    
    precomma, comma, postcomma = s.partition(old_sep)
    
    isnegative = False
    if (precomma.startswith(minus)):
        isnegative = True
        precomma = precomma.lstrip(minus)
    
    last = len(precomma) - 1
    formatted = [(cyc.next() if idx != last else '') + char for idx, char in enumerate(reversed(precomma))]
    formatted = ''.join(reversed(formatted))

    if isnegative:
        formatted = minus + formatted
    
    try:
        if (len(comma) != 0 and len(postcomma) != 0 and int(postcomma) != 0):
            formatted = formatted + com + postcomma
    except:
        #TODO: this try-except is a hack. In TC3.05 on Windows there was a problem converting
        #       something.5E+14 (postcomma=5E+14) where int(postcomma) fails
        #       -> further investigate this case and look for a cleaner solution
        formatted = formatted + com + postcomma
    
    return formatted


def convertDoubleToString(x,nDecimals=2,nMaxDigits=12):

#None's to blank space
    if x is None:
        result = ""
    else:
    #before continuing, assure that it's really a number
        try:
            x = float(x)
        except:
            result = str(x)
        else:
            if abs(x)>= pow(10.0,nMaxDigits):
                result = "%s" % x             
            else:
                formatstring = "%." + str(nDecimals) + "f"
                result = formatstring % x
#### commented out. gives error for numbers like 320.0 with 0 decimal digits.
#                result = result.rstrip("0")
    return result
    
if __name__ == "__main__":
    x = -17.389
    print x
    print convertDoubleToString(x,0)
    print convertDoubleToString(x,1)
    print convertDoubleToString(x,2)
    print convertDoubleToString(x,3)
    print convertDoubleToString(x,4)

    x = 320
    print x
    print convertDoubleToString(x,0)
    print convertDoubleToString(x,1)
    print convertDoubleToString(x,2)
    print convertDoubleToString(x,3)
    print convertDoubleToString(x,4)

