# -*- coding: utf-8 -*-
#==============================================================================
#
#	E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (<a href="http://www.einstein-energy.net/" target="_blank">www.einstein-energy.net</a>)
#
#------------------------------------------------------------------------------
#
#	PanelPRJ: project selection from database
#
#==============================================================================
#
#       EINSTEIN Version No.: 3.0
#
#------------------------------------------------------------------------------
#	(C) energyXperts.NET (E4-Experts GmbH), Berlin, Germany
#	http://www.energyxperts.net/
#
#==============================================================================

from GUI.einsteinPanel import EinsteinPanel
from GUI.dataEntry.tableEntry import TableEntry
from modules.guiModules.modulePRJ import ModulePRJ

from constants import PLATFORM


import wx
TABLESIZE = wx.Size(780, 525) if PLATFORM=="WIN" else wx.Size(785, 540) 

class PanelPRJ(EinsteinPanel):

    def __init__(self, parent, main):

        # generate list of notebook pages and frames
        layout = {"notebook": [],         # list of notebook-page titles. if empty or None, no notebook is created
                  "frames": [(None, _("Projects in data base"))]}           # list of frames (pageno, title). if empty, no frame is created
                                                            # pageno = None for frames on the main panel
        super(PanelPRJ, self).__init__(parent, main, layout)

        self.mod = ModulePRJ(self)

        # add panel specific entries
        titles = [_("Project name"), _("Description"), _("Branch")]

        self.addEntry("PRJList",
                      TableEntry(self, titles, self.mod.changeData, size=TABLESIZE,
                                 rowSize=32, colSize=225,
                                hAlignment = [wx.ALIGN_LEFT]*len(titles),
                                readOnly = [True]*len(titles),),
                      0)

        self.entry["PRJList"].setColSize(1, 300)
        self.entry["PRJList"].setPopUpMenu([_("copy"), _("delete")])
        self.entry["PRJList"].setExternalEventHandler(self.eventHandler)
        

        # conclude layout
        self.conclude_layout()


    def fillPanel(self):
        data, selection = self.mod.getTable()
        self.entry["PRJList"].display(data=data, choices=None, selection=selection)

    def eventHandler(self, eventType, r, c, selection):
        """ Handling of events in the PRJList - table        
        """
        
        if eventType == "LeftDclick":
            self.blockEventHandler = True
            self.mod.openProject(r)
            self.blockEventHandler = False

            self.prnt.Close()       
            self.prnt.Destroy()
        elif eventType in ["LeftClick"]:
            self.blockEventHandler = True
            self.mod.setSelection(selection)
            self.blockEventHandler = False

