#Boa:Dialog:DialogOK
#	Last revised by:    
#                           Stoyan Danov        19/06/2008
#                           Stoyan Danov    13/10/2008
#
#       Changes in last update:
#       19/06/2008 SD: change to translatable text _(...)
#       13/10/2008: SD  change _() to _U()
#------------------------------------------------------------------------------
#   (C) copyleft energyXperts.BCN (E4-Experts SL), Barcelona, Spain 2010
#   www.energyxperts.net / info@energyxperts.net
#
#   This program is free software: you can redistribute it or modify it under
#   the terms of the GNU general public license v3 as published by the Free
#   Software Foundation (www.gnu.org).
#
#==============================================================================
import wx
from auxiliary.auxiliary import toGettextAndUnicode as _U, toUnicode as U, toUTF8

[wxID_DIALOG, wxID_DIALOGBUTTONCANCEL, wxID_DIALOGBUTTONOK, 
 wxID_DIALOGSTDIALOG, 
] = [wx.NewId() for _init_ctrls in range(4)]

DEFAULTBUTTONSIZE = wx.Size(80, 24)

class DialogOKCancel(wx.Dialog):
    """ Template for a customisable dialog with OK and Cancel buttons
        Example for implementation: -> ProfileSelector
    """
    
    def __init__(self, prnt, title, size=wx.Size(400, 200), buttonSize=DEFAULTBUTTONSIZE, custom_layout=False):
        self.title = title
        self.size = size
        self.buttonSize = buttonSize
        wx.Dialog.__init__(self, id=wxID_DIALOG, name="dialogOKCancel", parent=prnt,
              pos=wx.Point(433, 286), size=self.size,
              style=wx.DEFAULT_DIALOG_STYLE, title=self.title)
        self.SetClientSize(size)

        self._init_ctrls(prnt)
        if not custom_layout: self._do_layout()


    def _init_ctrls(self, prnt):
        # generated method, don't edit

        self.buttonOK = wx.Button(id=wxID_DIALOGBUTTONOK, label=_U('OK'),
              name='buttonOK', parent=self,
              size=self.buttonSize, style=0)
        self.buttonOK.Bind(wx.EVT_BUTTON, self.OnButtonOK,
              id=wxID_DIALOGBUTTONOK)

        self.buttonCancel = wx.Button(id=wxID_DIALOGBUTTONCANCEL,
              label=_U('Cancel'), name='buttonCancel', parent=self,
              size=self.buttonSize, style=0)
        self.buttonCancel.Bind(wx.EVT_BUTTON, self.OnButtonCancel,
              id=wxID_DIALOGBUTTONCANCEL)

    def _do_layout(self, sizer=None):
        flagText = wx.ALIGN_CENTER_VERTICAL | wx.TOP

        if sizer is not None:           # sizer, as input, defined in child class
            sizerGlobal=sizer
        else:
            sizerGlobal = wx.BoxSizer(wx.VERTICAL)

        sizerOKCancel = wx.BoxSizer(wx.HORIZONTAL)
##        sizerOKCancel.Add(self.activeObject, 0, wx.ALL | wx.EXPAND, 2)
        sizerOKCancel.Add(self.buttonCancel, 0, wx.ALL | wx.EXPAND, 8)
        sizerOKCancel.Add(self.buttonOK, 0, wx.ALL | wx.EXPAND, 8)

        sizerGlobal.Add(sizerOKCancel, 0, wx.TOP | wx.ALIGN_RIGHT, 4)

        self.SetSizer(sizerGlobal)
        self.Layout()

    def OnButtonOK(self, event):
        self.EndModal(wx.ID_OK)

    def OnButtonCancel(self, event):
        self.EndModal(wx.ID_CANCEL)
