# -*- coding: utf-8 -*-
#==============================================================================
#
#    E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (<a href="http://www.iee-einstein.org/" target="_blank">www.iee-einstein.org</a>)
#
#------------------------------------------------------------------------------
#
#       catchPopUp: helper for generating pop-up menus
#
#==============================================================================
#
#	Version 3.0 (2018)
#
#------------------------------------------------------------------------------
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================
import wx

class PopUp():
    def __init__(self, prnt, items, pos):
        self.prnt = prnt
        self.index = None
        menu = wx.Menu()
        self.popUpMenuIds = [wx.NewId() for item in items]
        for i, title in enumerate(items):
            id = self.popUpMenuIds[i]
            menu.Append( id, title )
            wx.EVT_MENU(menu, id, self.OnPopUp)

        # Display menu with call to PopupMenu, invoked on the source component, passing event's GetPoint. ###
        prnt.PopupMenu(menu, pos)
        menu.Destroy() # destroy to avoid mem leak
        wx.SafeYield()
                                      
    def OnPopUp(self, event):
        self.index = self.popUpMenuIds.index(event.GetId())

def catchPopUp(prnt, items, pos):
    pu = PopUp(prnt, items, pos)
    return pu.index
     
