# -*- coding: utf-8 -*-
#==============================================================================
#
#   E I N S T E I N
#
#   Expert System for an Intelligent Supply of Thermal Energy in Industry
#   (www.einstein-energy.net)
#
#------------------------------------------------------------------------------
#
#   USERHELP
#
#------------------------------------------------------------------------------
#
#   Main menu option Help
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================
import os
import wx
import wx.html
import webbrowser
from constants import VERSION, RELEASE_VERSION, SUBVERSION, RELEASE_DATE


##def showUserManual(manualfile):
##    if os.access(manualfile, os.R_OK):
##        print "FrameHelpUserManual: Manual File found: ", manualfile
##        # if possible, load local manual
##        webbrowser.open_new("file://"+os.path.abspath(manualfile))   
##    else:
##        print "FrameHelpUserManual: Manual File not found: ", manualfile
##        # else, go to einstein site
##        webbrowser.open("http://einstein.sourceforge.net/")

class HTMLWindow(wx.html.HtmlWindow):
    def __init__(self, prnt, name):
        super(HTMLWindow, self).__init__(prnt, id=-1, pos=wx.DefaultPosition,
                                         style=wx.html.HW_SCROLLBAR_AUTO,
                                         name="name")
        if "gtk2" in wx.PlatformInfo:   
            self.SetStandardFonts()

    def OnLinkClicked(self, link):

        href = link.GetHref()
        if href.startswith("http") or href.startswith("mailto:"):
            wx.BeginBusyCursor()
            webbrowser.open(href)
            wx.EndBusyCursor()

        
class FrameHelpAbout(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, id=-1, name=u'FrameHelpAbout',
                           parent=parent, pos=wx.Point(50,50), size=wx.Size(800,600),
                           style=wx.DEFAULT_FRAME_STYLE, title='About')
        self.html = HTMLWindow(self, name="htmlAboutWindow")
                
        self.html.SetPage("<html><head><title>Einstein</title></head>"
		     "<body background=\"GUI/img/einstein_logo_bg.jpg\"><center>"
		     "<img src=\"GUI/img/einstein_logo.png\" width=\"480\", height=\"100\">"
		     "<br><br>"
		     "<b>Expert System for an Intelligent Supply of Thermal Energy in Industry</b><br>"
		     "<a href=\"http://www.einstein-energy.net\">www.einstein-energy.net</a><br>"
                     "<br><br>Version %s%s (%s)" % (VERSION, SUBVERSION, RELEASE_DATE) +
		     "<p>(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany&nbsp;2008-2020</p>"
		     "<p>Web page: <a href=\"http://www.energyxperts.net\">www.energyxperts.net</a></p>"
		     "<p>Email: <a href=\"mailto://info@energyxperts.net\">info@energyxperts.net</a></p>"
		     "<br><hr><br>"
		     "This program is distributed in the hope that it will be useful, "
                     "but WITHOUT ANY WARRANTY; without even the implied warranty of "
                     "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE"
                     "<br><br>"
                     "You can find a copy of the license in the documentation "
                     "of this software."
		     "</center></body></html>")

        aboutButtonOK = wx.Button(id=wx.ID_OK, label=u'OK', name='aboutButtonOK',
              parent=self, size=wx.Size(80,24))

        sz0 = wx.BoxSizer(wx.HORIZONTAL)
        sz0.Add(aboutButtonOK, 1, wx.ALL, 5)
        sz1 = wx.BoxSizer(wx.VERTICAL)
        sz1.Add(self.html, 1, wx.EXPAND, 5)
        sz1.Add(sz0, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sz1)



class FrameHelpSupport(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, id=-1, name=u'FrameHelpAbout',
              parent=parent, pos=wx.Point(50,50), size=wx.Size(600,400),
              style=wx.DEFAULT_FRAME_STYLE, title='Support')

        self.html = HTMLWindow(self, name="htmlSupportWindow")

        self.html.SetPage("<html><head><title>Einstein</title></head>"
		     "<body background=\"GUI/img/einstein_logo_bg.jpg\"><center>"
		     "<img src=\"GUI/img/einstein_logo.png\" width=\"480\", height=\"100\">"
		     "<br><br>"
		     "<b>Expert System for an Intelligent Supply of Thermal Energy in Industry</b><br>"
		     "<a href=\"http://www.einstein-energy.net\">www.einstein-energy.net</a><br>"
                     "<br><br>Version %s%s (%s)" % (VERSION, SUBVERSION, RELEASE_DATE) +
                     "<br><br>"
		     "User Manual and Documentation <br>"
                     "<a href=\"http://einstein.sourceforge.net\">einstein.sourceforge.net</a>"
		     "<br><br>"
		     "For getting support subscribe to the list of EINSTEIN users at <br>"
		     "</center></body></html>")

        aboutButtonOK = wx.Button(id=wx.ID_OK, label=u'OK', name='aboutButtonOK',
              parent=self, size=wx.Size(80,24))

        sz0 = wx.BoxSizer(wx.HORIZONTAL)
        sz0.Add(aboutButtonOK, 1, wx.ALL, 5)
        sz1 = wx.BoxSizer(wx.VERTICAL)
        sz1.Add(self.html, 1, wx.EXPAND, 5)
        sz1.Add(sz0, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sz1)
