# -*- coding: utf-8 -*-
#============================================================================== 				
#
#	ecoPy
#
#------------------------------------------------------------------------------
#
#	GLOBALS
#			
#------------------------------------------------------------------------------
#			
#	Contains all global parameters for the GUI
#
#==============================================================================
#
#------------------------------------------------------------------------------		
#	(C) copyleft energyXperts.BCN (E4-Experts SL), Barcelona, Spain 2008-2012
#	www.energyxperts.net / info@energyxperts.net
#
#	This program is free software: you can redistribute it or modify it under
#	the terms of the GNU general public license v3 as published by the Free
#	Software Foundation (www.gnu.org).
#
#==============================================================================

import gettext
from constants import LANGUAGES, updateConstants, translateConstants, APPDATA
from GUI.status import Status
from lib.auxiliary.float import FloatIO

import os
from lib.control.messageLogger import MessageLogger
trackFile = os.path.join(APPDATA, 'einsteinTrack.txt')   # tracking of movements of mirror
configFile = os.path.join(APPDATA, 'einstein.ini')
defaultConfigFile = 'control/default.ini'

class Globals():
    
    batchName = None    # batch name (batch execution only)
    projectFile = None  # active project data file

    GUI = None

    tracker = MessageLogger('track', trackFile, timeStamp=True, GUI=GUI)

    floatIO = FloatIO(tsep=" ", dc=".")     # standard display format for floats

    currency = "EUR"
    
    def setLanguage(self):
        import database.dbio as dbio
        stool = dbio.get("stool")
        LANGUAGE = stool.LanguageTool

##            LANGUAGE = Status.DB.stool.STool_ID[1][0].LanguageTool

        if LANGUAGE not in LANGUAGES:
            LANGUAGE = self.conf.get('GUI', 'LANGUAGE')

        if LANGUAGE not in LANGUAGES:
            LANGUAGE = 'en' #default -> set to English

        Status.LanguageTool = LANGUAGE

        stool.LanguageTool = LANGUAGE
                    
##        gettext.install("einstein", "locale", unicode=False)
##            
        if LANGUAGE == "cz":
            language = gettext.translation("einstein", "GUI/locale", languages=['cs_CZ'], fallback=True)
##            self.wxapp.i18n.Init("Czech", "cs_CZ")
        else:
            language = gettext.translation("einstein", "GUI/locale", languages=['%s' % (LANGUAGE,)], fallback=True)
##            self.wxapp.i18n.Init(LANGUAGE, LANGUAGE)
##        self.wxapp.i18n.AddCatalog("einstein")
        language.install()

        Status.TRANS = updateConstants()
        translateConstants()
        
##    def setUnitSystem(self):
##        import database.dbio as dbio
##        stool = dbio.get("stool")
##        selectedUnits = stool.UnitsTool
##
##        if selectedUnits in UNITSYSTEM.keys():
##            Status.Units = selectedUnits
##        else:
##            Status.Units = "SI-kWh"
##            stool.UnitsTool = Status.Units

                            
logger = Globals.tracker
