# -*- coding: utf-8 -*-
#==============================================================================                 
#
#	 E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (www.iee-einstein.org)
#
#------------------------------------------------------------------------------
#
#    CCEquation (Consistency Check)
#            
#------------------------------------------------------------------------------
#            
#    Short description:
#    
#    New class for building equations for consistency check
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------        
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================                 
from math import fabs, log, exp
from constants import *                
from modules.messageLogger import *
from GUITools import *     #needed for function check
from ccTracker import estimateTracker, screen, conflict, cycle
import numpy as np

global DEBUG
EPSILON = 1.e-10     # required accuracy for function "isequal"
INFINITE = 1.e99    # numerical value assigned to "infinite"
MINIMUM_VALUE = 1.e-10
DEFAULT_SQERR = 1.e-6 # default value for sqerr assigned to questionnaire values (until V2.1 default had been set to 1e-4)
NUMERIC_ERR = 1.e-10 # accuracy of numeric calculations
CONFLICT_ERR = 1.e-6
MAX_SQERR = 0.09     # critical square error for screening
CONFIDENCE = 4.0    # maximum relation between statistical error and abs.min/max
CHECKMODE = "BEST"  # MEAN or BEST. MEAN recommened as BEST doesn't give consistent results
MAXTRACKENTRIES = 10 # maximum number of variables to be tracked

class CCEquation():
    """ class for defining an equation to be used within a CC-Block
    """

    def __init__(self, name, eqType, x, par=[]):
        """Create new CCPar (consistency check parameter).
        
        :param name: The (human readable) name of the equation
        :param eqType: Can be one of the following:
                        PROD
                        SUM
                        DIFF
        :param x: a vector of variables (type CCPar) of an ecuation y:= x0 = f(x1, x2, x3)
        :param par: a list of constant parameters (float)
        
        """
        # TODO: what means priority
        self.name = name
        self.eqType = eqType
        self.xbase = x
        

    def buildEquation(self):
        """
        """
        self.x = []
        for x in self.xbase:
            xbase.push()
            self.x.append(xbase.stack[0])



    def calcMinMax(self):
        """ re-calculates the minimum and maximum values for all parameters
        """
        

    def calcVal(self):
        """ updates the estimates (val) for all parameters
        """
        if self.type == "PROD":
            calcProdC(self.x[0], a, self.x[1], self.x[2]
            adjustProdC(self.x[0], a, self.x[1], self.x[2]
            
    def check(self):
        """checks immediately """
       CONTINUE HERE
