# -*- coding: cp1252 -*-
#==============================================================================
#
#	E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (www.iee-einstein.org)
#
#------------------------------------------------------------------------------
#
#	MODULES
#			
#------------------------------------------------------------------------------
#			
#	Instances of modules for global access
#
#==============================================================================
#
#	Version 2.3plus, 30.06.2015
#
#------------------------------------------------------------------------------		
#
#	(C) copyright energyXperts.NET (E4-Experts GmbH), Berlin, Germany 2008-2015
#	http://www.energyxperts.net
#
#	all rights reserved
#
#==============================================================================

from ccheck.moduleCC import ModuleCC
from moduleBM import ModuleBM
from energy.moduleEnergy import ModuleEnergy
from heatRecovery.moduleHR import ModuleHR
from moduleHC import ModuleHC
from chp.moduleCHP import ModuleCHP
from solar.moduleST import ModuleST
from heatPump.moduleHP import ModuleHP
from boiler.moduleBB import ModuleBB
from chiller.moduleCH import ModuleCH
from energyStats.moduleEA import ModuleEA
from economy.moduleECO import ModuleECO
from messageLogger import *

class Modules(object):
    
#------------------------------------------------------------------------------		
    def __init__(self):
#------------------------------------------------------------------------------		

        logDebug("Modules (__init__): creating module instances")

        self.moduleCC = ModuleCC()
        
        keys = ['BM Table'] 
        self.moduleBM = ModuleBM(keys)
        
        keys = ['ENERGY','ENERGY Plot1'] 
        self.moduleEnergy = ModuleEnergy(keys)

        keys = ['HR Table', 'HR Pars'] 
        self.moduleHR = ModuleHR(keys)
        
        keys = ['HC Table'] 
        self.moduleHC = ModuleHC(keys)
        
        keys = ['CHP Table'] 
        self.moduleCHP = ModuleCHP(keys)

        keys = ['ST Table'] 
        self.moduleST = ModuleST(keys)
        
        keys = ['HP Table'] 
        self.moduleHP = ModuleHP(keys)
        
        keys = ['BB Table'] 
        self.moduleBB = ModuleBB(keys)

        keys = ['CH Table']
        self.moduleCH = ModuleCH(keys)

        self.moduleEA = ModuleEA()
       
        keys = ["TCA"]
        self.moduleECO = ModuleECO(keys)

#------------------------------------------------------------------------------		
