class PeriodScheduleBuilder():
    """ generates the data for the visualisation of the period scales

    :param periods:  list of PeriodProfile - objects
    :param holidays: sorted list of holiday intervals (in hours !!!)
    
    """

    def __init__(self, periods, holidays=None, holidayScale=None):

        intervals = [(period.startHour(), period.stopHour(), period.scale) for period in periods]
        self.bs = BasicSchedule()
        self.bs.getPeriods(intervals, default=0.0, tmin=0, tmax=8760)

        if holidays: # add holidays if defined
            hPeriods = [(holidayPeriod[0], holidayPeriod[1], holidayScale) for holidayPeriod in holidays]
            bsh = BasicSchedule()
            bsh.getPeriods(hPeriods, default=1.0, tmin=0, tmax=8760)
                            
            # multiply bs(t)*bsh(t)
            self.bs.multiply(bsh)

        self.gs = self.bs.toPeriods()



