# -*- coding: utf-8 -*-
#==============================================================================
#
#    E I N S T E I N
#
#       Expert System for an Intelligent Supply of Thermal Energy in Industry
#       (<a href="http://www.iee-einstein.org/" target="_blank">www.iee-einstein.org</a>)
#
#------------------------------------------------------------------------------
#
#    iconGrid: abstract grid for positioning of icons on the screen
#
#==============================================================================
#
#    (C) energyXperts.NET (E4-Experts GmbH), Berlin, Germany, 2017
#    http://www.energyxperts.net/
#
#==============================================================================
class IconGrid():
    """ grid[r][c] contains the number of the icon (from 0 to n-1), or None if empty

    """

    def __init__(self, nnodes):
        self.grid = []
        self.nodes = []
        self.nrows = 0
        self.ncols = 0
        self.remainingNodes = range(nnodes)

    def extend(self, nrows, ncols):
        if nrows > self.nrows:
            for i in range(self.nrows, nrows):
                self.grid.append([None]*self.ncols)
            self.nrows = nrows

        if ncols > self.ncols:
            for r, row in enumerate(self.grid):
                self.grid[r] += [None]*(ncols - self.ncols)

            self.ncols = ncols

    def addNode(self, n, r, c):
        if n not in self.nodes:
            self.extend(r+1, c+1)
            self.grid[r][c] = n
            self.nodes.append(n)

            index = self.remainingNodes.index(n)
            self.remainingNodes.pop(index)

            return True
        else:
            return False
                                        

    def insertCol(self, c):
        """ inserts a new column to the left of existing column c
        """
        for r, row in enumerate(self.grid):
            self.grid[r].insert(c, None)
        self.ncols += 1



        
    
