from constants import APPDATA
from lib.text.textConversion import toUnicode as U, toUTF8
import wx

def pickFile(message=_("open file"), wildcard="*.*", rootDir=APPDATA, defaultFile=None, new=False):
    """ open some file """

    style = (wx.FD_OPEN | wx.FD_PREVIEW) if new else (wx.FD_OPEN | wx.FD_FILE_MUST_EXIST | wx.FD_PREVIEW)
    dialog = wx.FileDialog(parent=None,
                           message=U(message),
                           defaultDir=U(rootDir),
                           defaultFile=U(defaultFile),
##                           wildcard='Open Office spreadsheets files (*.ods)|*.ods',
                           wildcard=U(wildcard),
                           style=style)

    if dialog.ShowModal() == wx.ID_OK:
        filePath = toUTF8(dialog.GetPath())
    else:
        filePath = None

    # return local path if within APPDATA
    if filePath is not None and filePath.startswith(rootDir):
        filePath = filePath[len(rootDir)+1:]
        
    return filePath
