import wx

class RangeSlider(wx.Slider):
    def __init__(self, prnt, *args, **kwargs):

        self.prnt = prnt
        wx.Slider.__init__(self, prnt, *args, **kwargs)
        self.left_gap = 50
        self.right_gap = 50
        self.Bind(wx.EVT_LEFT_UP, self.on_left_click)
        self.Bind(wx.EVT_RIGHT_UP, self.on_right_click)
##        self.Bind(wx.EVT_SCROLL_PAGEUP, self.on_pageup)
##        self.Bind(wx.EVT_SCROLL_PAGEDOWN, self.on_pagedown)
        self.Bind(wx.EVT_SCROLL_THUMBTRACK, self.on_slide)

        self.slider_value=self.Value
        self.is_dragging=False

        self.SetSelection(2000, 3000)

        self.Show()

    def linapp(self, x1, x2, y1, y2, x):
        proportion=float(x - x1) / (x2 - x1)
        length = y2 - y1
        return round(proportion*length + y1)

    # if left click set the start of selection
    def on_left_click(self, e):
        if not self.is_dragging: #if this wasn't a dragging operation
            position = self.get_position(e)
            if position <= self.SelEnd:
                self.SetSelection(position, self.SelEnd)
            else:
                self.SetSelection(self.SelEnd, position)
        else:
            self.is_dragging = False

            if hasattr(self.prnt, "onSlider"): self.prnt.onSlider(self.Value)
##            evt = wx.CommandEvent(wx.EVT_SLIDER.evtType[0])
##            wx.PostEvent(self.GetEventHandler(), evt)
        e.Skip()

    # if right click set the end of selection
    def on_right_click(self, e):
        position = self.get_position(e)
        if position >= self.SelStart:
            self.SetSelection(self.SelStart, position)
        else:
            self.SetSelection(position, self.SelStart)
        e.Skip()

    # drag the selection along when sliding
    def on_slide(self, e):
        self.is_dragging=True
        delta_distance=self.Value-self.slider_value
        self.SetSelection(self.SelStart+delta_distance, self.SelEnd+delta_distance)
        self.slider_value=self.Value
##
##    # disable pageup and pagedown using following functions
##    def on_pageup(self, e):
##        self.SetValue(self.Value+self.PageSize)
##
##    def on_pagedown(self, e):
##        self.SetValue(self.Value-self.PageSize)
##
    # get click position on the slider scale
    def get_position(self, e):
        click_min = self.left_gap #standard size 9
        click_max = self.GetSize()[0] - self.right_gap #standard size 55
        click_position = e.GetX()
        result_min = self.GetMin()
        result_max = self.GetMax()
        if click_position > click_min and click_position < click_max:
            result = self.linapp(click_min, click_max,
                                 result_min, result_max,
                                 click_position)
        elif click_position <= click_min:
            result = result_min
        else:
            result = result_max

        return result
