from scipy.optimize import leastsq
import numpy as np


def f(x):
    a = 1
    b = 1
    c = 1
    d = 4
    return a*np.array([c*x[0]+x[1]-2, c*x[0]+x[1]-2-d, b*x[0]])


output = leastsq(f, np.zeros(2), full_output=True)

cov_f = output[1]
fvec = output[2]["fvec"]
res = np.sum(np.square(fvec))/len(fvec)

print output
print "cov_f: ", cov_f
print "res: ", res
print "res*cov_f: ", res*cov_f




# notes
# the resulting matrix cov_f is
# - inversely proportional to a**2 (res*cov_f unchanged)
# - the coeficcient cov_f[0][0] is inversely proportional to b, leaving
#   cov_f[1][1] unchanged. (res*cov_f changed for [0][0] only) prop b**-2
# - the coefficient c=0/c=1 is irrelevant to the result (also for res*cov_f)
# - the change of d from 2 to 4 leaves cov_f unchanged (res*cov_f multiplies by 4
#   note: changes accuracy for both x[0] and x[1]
#  conclusion: the best measure for stddev is sqrt(res*cov_f)
