from scipy.optimize import leastsq
import numpy as np

#### the generation of cov_f in a very simple default case f(x) = a*x
#### depends strongly on the parameter a (for a < 0.5 in default settings
#### no cov_f is generated, unless ftol is set to 1.0


xo = np.zeros(1)


xo[0] = 1.

def f(x):
    return 0.001*x


output = leastsq(f,
                 xo,
                 full_output=True,
                 ftol=1.,
                 factor=1)

x = output[0]

cov_f = output[1]
fvmin = output[2]["fvec"]
fmin = np.sum(np.square(fvmin))
msg = output[3]
ier = output[4]

print "x: %s"%x
print "cov_f: %s"%cov_f
print "fmin: %s"%fmin
print "IER: %s MSG: %s "%(ier, msg)

