from constants import EPSILON, KELVIN, INFINITE

# Carnot efficiency.
def carnotEfficiency(Th, Tc):
    """
    Carnot Efficiency for conversion into work
    """
    if Th is None or Tc is None:
        return None
    elif Th <= Tc:
        return 0.0
    else:
        return (Th - Tc)/(Th + KELVIN)

def carnotCOPh(Th, Tc):
    """
    Carnot Efficiency - heat pump - heating
    """
    if Th is None or Tc is None:
        return None
    elif Th <= Tc:
        return INFINITE
    else:
        return (Th + KELVIN)/(Th - Tc)

def carnotCOPc(Th, Tc):
    """
    Carnot Efficiency - heat pump - cooling
    """
    if Th is None or Tc is None:
        return None
    elif Th <= Tc:
        return INFINITE
    else:
        return (Tc + KELVIN)/(Th - Tc)
    
    
